

#include "headers.h"

///// Trace function for SQLExecDirect /////

RETCODE SQL_API TraceSQLExecDirect  (HSTMT arg0,
		 UCHAR * arg1,
		 SDWORD arg2)
{
	LPTRACESTR	lpCallStr = (LPTRACESTR) malloc(sizeof(TRACESTR));
	if (lpCallStr == NULL)
		return 0;
	memset(lpCallStr,0,sizeof(TRACESTR));
	lpCallStr->dwCallFunc = SQL_API_SQLEXECDIRECT;
	lpCallStr->szFuncName="SQLExecDirect";
	lpCallStr->lpvArg[0] = (LPVOID) arg0;
	lpCallStr->szArg[0]="HSTMT";
	lpCallStr->atArg[0]=TYP_HSTMT;
	lpCallStr->lpvArg[1] = (LPVOID) arg1;
	lpCallStr->szArg[1]="UCHAR *";
	lpCallStr->atArg[1]=TYP_UCHARPTR;
	lpCallStr->lpvArg[2] = (LPVOID) arg2;
	lpCallStr->szArg[2]="SDWORD";
	lpCallStr->atArg[2]=TYP_SDWORD;
	lpCallStr->nArgs = 3;
	DoTrace(lpCallStr);
	return((RETCODE)SetNextHandle(lpCallStr));
}

///// Trace function for SQLExecute /////

RETCODE SQL_API TraceSQLExecute  (HSTMT arg0)
{
	LPTRACESTR	lpCallStr = (LPTRACESTR) malloc(sizeof(TRACESTR));
	if (lpCallStr == NULL)
		return 0;
	memset(lpCallStr,0,sizeof(TRACESTR));
	lpCallStr->dwCallFunc = SQL_API_SQLEXECUTE;
	lpCallStr->szFuncName="SQLExecute";
	lpCallStr->lpvArg[0] = (LPVOID) arg0;
	lpCallStr->szArg[0]="HSTMT";
	lpCallStr->atArg[0]=TYP_HSTMT;
	lpCallStr->nArgs = 1;
	DoTrace(lpCallStr);
	return((RETCODE)SetNextHandle(lpCallStr));
}

///// Trace function for SQLPrepare /////

RETCODE SQL_API TraceSQLPrepare  (HSTMT arg0,
		 UCHAR * arg1,
		 SDWORD arg2)
{
	LPTRACESTR	lpCallStr = (LPTRACESTR) malloc(sizeof(TRACESTR));
	if (lpCallStr == NULL)
		return 0;
	memset(lpCallStr,0,sizeof(TRACESTR));
	lpCallStr->dwCallFunc = SQL_API_SQLPREPARE;
	lpCallStr->szFuncName="SQLPrepare";
	lpCallStr->lpvArg[0] = (LPVOID) arg0;
	lpCallStr->szArg[0]="HSTMT";
	lpCallStr->atArg[0]=TYP_HSTMT;
	lpCallStr->lpvArg[1] = (LPVOID) arg1;
	lpCallStr->szArg[1]="UCHAR *";
	lpCallStr->atArg[1]=TYP_UCHARPTR;
	lpCallStr->lpvArg[2] = (LPVOID) arg2;
	lpCallStr->szArg[2]="SDWORD";
	lpCallStr->atArg[2]=TYP_SDWORD;
	lpCallStr->nArgs = 3;
	DoTrace(lpCallStr);
	return((RETCODE)SetNextHandle(lpCallStr));
}


///// Trace function for SQLBindParameter /////

RETCODE SQL_API TraceSQLBindParameter  (HSTMT arg0,
		 UWORD arg1,
		 SWORD arg2,
		 SWORD arg3,
		 SWORD arg4,
		 UDWORD arg5,
		 SWORD arg6,
		 PTR arg7,
		 SDWORD arg8,
			UNALIGNED SDWORD * arg9)
{
	LPTRACESTR	lpCallStr = (LPTRACESTR) malloc(sizeof(TRACESTR));
	if (lpCallStr == NULL)
		return 0;
	memset(lpCallStr,0,sizeof(TRACESTR));
	lpCallStr->dwCallFunc = SQL_API_SQLBINDPARAMETER;
	lpCallStr->szFuncName="SQLBindParameter";
	lpCallStr->lpvArg[0] = (LPVOID) arg0;
	lpCallStr->szArg[0]="HSTMT";
	lpCallStr->atArg[0]=TYP_HSTMT;
	lpCallStr->lpvArg[1] = (LPVOID) arg1;
	lpCallStr->szArg[1]="UWORD";
	lpCallStr->atArg[1]=TYP_UWORD;
	lpCallStr->lpvArg[2] = (LPVOID) arg2;
	lpCallStr->szArg[2]="SWORD";
	lpCallStr->atArg[2]=TYP_SWORD;
	lpCallStr->lpvArg[3] = (LPVOID) arg3;
	lpCallStr->szArg[3]="SWORD";
	lpCallStr->atArg[3]=TYP_SWORD;
	lpCallStr->lpvArg[4] = (LPVOID) arg4;
	lpCallStr->szArg[4]="SWORD";
	lpCallStr->atArg[4]=TYP_SWORD;
	lpCallStr->lpvArg[5] = (LPVOID) arg5;
	lpCallStr->szArg[5]="UDWORD";
	lpCallStr->atArg[5]=TYP_UDWORD;
	lpCallStr->lpvArg[6] = (LPVOID) arg6;
	lpCallStr->szArg[6]="SWORD";
	lpCallStr->atArg[6]=TYP_SWORD;
	lpCallStr->lpvArg[7] = (LPVOID) arg7;
	lpCallStr->szArg[7]="PTR";
	lpCallStr->atArg[7]=TYP_PTR;
	lpCallStr->lpvArg[8] = (LPVOID) arg8;
	lpCallStr->szArg[8]="SDWORD";
	lpCallStr->atArg[8]=TYP_SDWORD;
	lpCallStr->lpvArg[9] = (LPVOID) arg9;
	lpCallStr->szArg[9]="SDWORD *";
	lpCallStr->atArg[9]=TYP_SDWORDPTR;
	lpCallStr->nArgs = 10;
	DoTrace(lpCallStr);
	return((RETCODE)SetNextHandle(lpCallStr));
}
