/*
** init.c - This module contains the DLL initialization functions
**
**   1991 - 1999 Microsoft Corporation. All rights reserved.
*/



/*

  TESIS: PROTOTIPO DE REPLICACIN DE BASES DE DATOS MEDIANTE ODBC
  AUTOR:		      DANIEL LEAL LARIS
  FECHA DE CREACIN:  15/07/2002 

  NOMBRE:    Loyal.dll
  


  Esta DLL fue modificada de su versin Original.

  Objetivo:
    
  Realizar  un  seguimiento,  no tan detallado como en la versin original, donde
  se registren exclusivamente las sentencias SQL que han sido ejecutadas de forma
  satisfactoria.
  

  En la presente versin de la DLL, solo se incluyen las siguientes funciones 
  para su seguimiento:
  
  TraceSQLExecDirect
  TraceSQLPrepare
  TraceSQLExecute


  Aqui es importante aclarar que, en una aplicacin ODBC, para ejecutar transacciones
  no solo se usan estas funciones, pero para fines de este protipo se tomarn en cuenta
  las mas comunes.
  

  El proceso principal se describe a continuacin :
  
	
    a)  Inicializar DLL, obtener Direccin Ip del servidor y el puerto
	    por el cual est escuchando mensajes 
	    mediante la DLL ObtenIPPuerto.dll

    b)  Llamar a la funcin de seguimiento

    c)	Dentro de la funcin ProcessTrace:
		si la sentencia no es SELECT (puede ser INSERT, UPDATE  DELETE),
	 	copiala	a un Buffer, escribela en el Archivo de Seguimiento y
		Mandala mediante un socket al Servidor que este Replicando 
		[LoyalServer] en algun lugar de la RED por la funcin SendSocket
	
	  
  

  Puesto que la presente DLL es una adaptacin de una DLL que es ejecutada  por  el
  manejador de controladores, que no esta bajo el estandar de orientado  a  objetos,
  el formato de las funciones ha quedado igual no se ha cambiado mucho, ha excepcin 
  de la implementacin de una nueva funcion, y la 
  modificacin de una nueva funcin:
  
  1.- Una funcin externa desde otra DLL (ObtenIpPuerto.dll) cargada explicitamente
      que como lo dice su nombre  obtiene la IP y el Puerto del archivo "Loyal.ini" 
	  donde se espcifica la direccin y el puerto del servidor a Replicar.
  2.- La modificacin de la funcin 'ProcessTrace', para realizar la tarea 
	  descrita anteriormente en el inciso c



  ADVERTENCIA: Para que este programa se pueda compilar, es necesario incluir la libreria 
  Wsock32.lib en project -> settings -> link.   

  UNA VEZ GENERADO ESTA DLL ES NECESARIO COPIARLA AL DIRECTORIO DEL SISTEMA
  DE WINDOWS, JUNTO CON LA DLL ObtenIpPuerto.dll


*/







#include "headers.h"


#include <windows.h>


DWORD	*pdwGlobalTraceVariable;
DWORD	*pdwGlobalVistaVariable;
HANDLE	g_hOdbcDM;

CRITICAL_SECTION	g_csWrite;

char    *AddressDest ;
int Port ;


/* libmain() - Std DLL entry point, called from libentry.asm */
BOOL  WINAPI DllMain(HANDLE hInst,
					DWORD ul_reason_being_called,
					LPVOID lpReserved)
{

	HINSTANCE hinst = LoadLibrary("ObtenIpPuerto.dll");
    int  (*Porto) (void)  =  (int (*) (void)) GetProcAddress(hinst,"ObtenPuerto") ;  
    char  (*AddressD) (int)   =  (char (*) (int) ) GetProcAddress(hinst,"ObtenIp") ;
    char AddressDest1[16];
    int i;


    switch (ul_reason_being_called) 
	{
		case DLL_PROCESS_ATTACH:


     Port = Porto();
    
	for(i=0;i<=15;i++)
	{
	   AddressDest1[i] =  AddressD(i);
	}



    //AddressDest =  (char *) AddressDest1;
  
			FreeLibrary(hinst);

			AddressDest  = (char *) malloc(15);
			AddressDest[15]=0;
 
			for(i=0;i<15;i++)
		    AddressDest[i]=AddressDest1[i]; 


			// We do not need the thread attach/detach calls  /  Who said that?? Daniel
		 	
			DisableThreadLibraryCalls(hInst);
			g_hOdbcDM = LoadLibraryA("odbc32.dll");
			if (g_hOdbcDM)
			{
				pdwGlobalTraceVariable = (DWORD *) GetProcAddress(g_hOdbcDM, "ODBCSharedTraceFlag");
				pdwGlobalVistaVariable = (DWORD *) GetProcAddress(g_hOdbcDM, "ODBCSharedVSFlag");
			}
			InitializeCriticalSection(&g_csWrite);
			break;

    	case DLL_PROCESS_DETACH:
			FreeLibrary(g_hOdbcDM);
			break;

	/* no need for these cases
    	case DLL_THREAD_ATTACH:
    	case DLL_THREAD_DETACH:
	*/
		default:
			break;

	} /* switch */

    return 1;
    UNREFERENCED_PARAMETER(lpReserved);
}

