/*

  TESIS: PROTOTIPO DE REPLICACIN DE BASES DE DATOS MEDIANTE ODBC
  AUTOR:		      DANIEL LEAL LARIS
  FECHA DE CREACIN:  06/07/2002 

  NOMBRE:    LoyalServer.exe 


  Este cdigo hace la funcin de Servidor y realiza las
  siguientes tareas en el siguiente orden: 
  
  1.- Acepta los siguentes paramtros:
      a) Direccin IP del Servidor 
      b) Puerto de conexin
          (es decir el puerto por el cual el servidor recibir peticiones )
      c) Nombre del Servidor de Base de Datos local (DBMS)
          de acuerdo con el DNS de ODBC previamente creado
      d) Nombre del usuario con el que se har la conexin
         de acuerdo con el DNS de ODBC previamente creado
      c) Contrasea del usuario 

 
  2.- Verifica que se soporte la tecnologa socket de escuchar peticiones
  3.- Se conecta a una base  de datos 
  4.- Comienza a Escuchar Peticiones de Sentencias SQL
  5.- Ejecuta las Sentencias SQL que van llegando


  ADVERTENCIA: Para que este programa se pueda compilar, es necesario incluir la libreria 
  Wsock32.lib en project -> settings -> link.   


  A diferencia de la codificacin de la DLL que se  ubica en el cliente, este programa
  esta creado bajo los estandares de la programacin orientada a objetos.

  Para el mejor manejo del archivo ejecutable se puede correr el archivo por lotes (.bat)
  LoyalServer.bat donde se pueden especificar los parmetros previamente definidos, 
  el exe  junto con su archivo por lotes puede estar ubicado en cuanquier parte del sistema, 
  y se ejcutara correctamente siempre y cuando sus parmetros sean validos.
 



*/


#include <winsock.h>
#include <sys/types.h> 
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <iostream.h>

#include "sql.h"
#include "sqlext.h"



//Librerias Creadas 
#include "LoyalServer.h"
#include "OdbcCon.h"





int main(int argv1,  char **argv2)
{



/*

Valores para sqlbindparameter

*/



  //UWORD arg1;
  //SWORD arg2;
  //SWORD arg3;
  //SWORD arg4;
  //UDWORD arg5;
  //SWORD arg6;
  //PTR arg7;
  //SDWORD arg8;
  //SDWORD * arg9;



    SQLUSMALLINT arg1;
    SQLSMALLINT  arg2;
    SQLSMALLINT  arg3;
    SQLSMALLINT  arg4;
    SQLUINTEGER  arg5;
    SQLSMALLINT  arg6;
  
    SQLINTEGER   arg8;

	SQLINTEGER   arg9;

    


	

/*

Valores para sqlbindparameter

*/



  int t=0;
  int a=0;


  char *stopstring;
  char DatosEntrada[2000];
  char  DatosSalida[2000];

  //El stm (sentencia) se copiara a  esta variable
  char	szBuffer[2000];
  char	*pzBuffer[2000];
  char textopantalla[600];
  char  *pdest = NULL; 

  char	AuxszBuffer[2000];
  
  
  //char *a[2000];
  SQLPOINTER   *arg7[100];
//  int          *arg7i[100];

  const char *SrcIPAddr=  argv2[1]; 
  static int nummsg=0;



  int x=0;
  int y=0;
  int z=0;
  int w=0;
  


  int  *DatoInt;



  int IPPort; 
  int res;
  char peticion='0';
  long cuantosLeidos;

  IPPort = (int) strtod( argv2[2], &stopstring );
  printf("\n %s",SrcIPAddr); 
  printf("\n %i",IPPort); 



  textopantalla[600]=0;
  
  DatoInt  =  (int *) malloc(sizeof(int));	




  WSADATA	wsaData;
  WORD      sockVersion = MAKEWORD(1,1);	

    //Validando si se soporta la comunicacin mediante SOCKETS
      res = WSAStartup(sockVersion, &wsaData);

  if (res == 0)
  {
     //Crear una instancia de la clase Servidor
	  
     CServidor servidor(SrcIPAddr,IPPort);
	 printf("\n Servidor Escuchando Peticiones del Cliente") ;

     SQLRETURN     rc   = SQL_SUCCESS;
     UCHAR * servidorStr    = (UCHAR *)argv2[3];
	 UCHAR * usuario        = (UCHAR *)argv2[4] ;
	 UCHAR * contrasenia    = (UCHAR *)argv2[5]; 






    // Crear una Instancia de la clase de ODBC
     ODBC_Class  CnBd;

    // Conectarse a la base de datos apropiada - si es satisfactoria,
    // Desplegar el mensaje apropiado

  if (CnBd.ConHandle != NULL)
   {
        

	     // Inicia Conexin
	rc = SQLConnect(CnBd.ConHandle, servidorStr, SQL_NTS,  usuario, SQL_NTS,  contrasenia, SQL_NTS);


      if (rc == SQL_SUCCESS || rc == SQL_SUCCESS_WITH_INFO)
	  {
            printf("\n Servidor LoyalServer Conectado Satisfactoriamente a la Base de Datos ") ;

            rc = SQLAllocStmt(CnBd.ConHandle, &CnBd.StmtHandle);


            // Verifica se acepten sentencias SQL en el Manejador de Base de Datos

		    if( rc == SQL_SUCCESS)
			{

      		    do{
					
					//Inicia servicio de escucha	
					if(servidor.servicio(DatosEntrada,2000,cuantosLeidos)==OK)
					
						{
					
						
						    pdest = NULL;

							DatosEntrada[cuantosLeidos]=0;
							DatosSalida[cuantosLeidos]=0;
							szBuffer[cuantosLeidos]=0;
						   
							
						   _snprintf(szBuffer,sizeof(szBuffer)," %s \r\n",DatosEntrada);
						   _snprintf(AuxszBuffer,sizeof(AuxszBuffer)," %s \r\n",DatosEntrada);
						  
						  
						   
						   pdest = strstr(strupr(AuxszBuffer),"SQLPREPARE");
												   
								if (pdest != NULL  ||  x>0) 
						
								{

									    x++; 
									if (x>1)
									{

										sprintf(textopantalla,"\r\n Msg(%d). \r\n Preparando Sentencia SQL [%s]", ++nummsg, szBuffer);
										printf("%s", textopantalla);

							
									// Prepara Sentencia
                           
										if(SQLPrepare(CnBd.StmtHandle, (UCHAR *) szBuffer, SQL_NTS) != SQL_SUCCESS)
										{
											printf("\n Existio un Problema al Preparar Sentencia");
										}
										else
										{
											printf("\n La Sentencia se Preparo Satisfactoriamente");
										}
					

										x=0;
					
									}

			
								}




								pdest = strstr(strupr(AuxszBuffer),"SQLEXECUTE");
												   
								if (pdest != NULL  ||  w>0) 
						
								{	
									 
									  w++; 

									if (w>0)
									{

										t=0;
									    a=0;
										printf("%i",w);
										sprintf(textopantalla,"\r\n Msg(%d). \r\n Ejecutando Sentencia SQL ", ++nummsg);
										printf("%s", textopantalla);
										
										// Ejecuta Sentencia
                           
										if(SQLExecute(CnBd.StmtHandle) != SQL_SUCCESS)
										{
											printf("\n Existio un Problema al Ejecutar Sentencia");
										}
										else
										{
											printf("\n La Sentencia se Ejecuto Satisfactoriamente");
										}

									  _flushall();
									  w=0;	


									}	
								
								}	

								





								pdest = strstr(strupr(AuxszBuffer),"SQLBINDPARAMETER");
								
								if (pdest != NULL || y>0) 
									
								{
									   y++;

									   if(y>1)
									   {

						
							            sprintf(textopantalla,"\r\n Msg(%d). \r\n Valor SQLBindParameter [%s]", ++nummsg, szBuffer);
										printf("%s", textopantalla);
									    printf("%i",y); 

													switch(y)

													{											
										   		      case 2:

												      arg1 = (unsigned short) strtol( szBuffer, &stopstring, 10 );
													  
													  break;

												      case 3:


													  arg2 = (short) strtol( szBuffer, &stopstring, 10 );
													  
													  break;

													  case 4:

													  arg3 = (short) strtol( szBuffer, &stopstring, 10 );
											 
													  break;

													  case 5:
														
													  arg4 =  (short)  strtol( szBuffer, &stopstring, 10 );

													  break;

													  case 6:

													  arg5 = (short) strtol( szBuffer, &stopstring, 10 );
										
													  break;
										   
													  case 7:
					
													  arg6 = (short) strtol( szBuffer, &stopstring, 10 );

													  break;

													  case 8:

													  t++;

													  pzBuffer[t] =(char *)malloc(2000*sizeof(char));
													  strcpy(pzBuffer[t],DatosEntrada);
										    
		
															if(arg3==1)

															{

																arg7[t] = (SQLPOINTER *) malloc(100*sizeof(SQLPOINTER));	
																arg7[t] = (SQLPOINTER *) pzBuffer[t];
																arg9    = SQL_NTS;
				
															}
															  else if(arg3==4)

															{
																
																  a++;

																  
																  DatoInt[t]  = (int) strtol( pzBuffer[t], &stopstring, 10 );	

																 
																  
																  
																  //printf("\n%i",arg7[t]);
																 
																 /*printf("\n%i",DatoInt[a]);
																 printf("\n%i",&DatoInt[a]);
																 printf("\neste%i",arg7i[a]);
																 printf("\n%i",&arg7i[a]);*/
																 

																 arg9 = 0;
		
															}



												
												       break;
										   
										   
													   case 9:


														  arg8 = strtol( szBuffer, &stopstring, 10 );
 													      break;

													}	




   
   
						if(y==9)
						{	
						  y=0;
											
										  
	 

										//if(SQLBindParameter(CnBd.StmtHandle, arg1, arg2, arg3, arg4, arg5, arg6, arg7[t], arg8, &arg9 ) != SQL_SUCCESS)   cambie t por a en interos

									if(arg3==1)
								{
								
									    if(SQLBindParameter(CnBd.StmtHandle, arg1, arg2, arg3, arg4, arg5, arg6, arg7[t], arg8, &arg9 ) != SQL_SUCCESS)
										{
											printf("\n Existio un Problema al Ligar Parametro");
										}
										else
										{
											printf("\n EL Parametro se ligo Satisfactoriamente");
										
										}
									
									
								}
								else if(arg3==4)
								{
												
									printf("\n%i",DatoInt[a]);
									printf("\n%i",&DatoInt[a]);
										if(SQLBindParameter(CnBd.StmtHandle, arg1, arg2, arg3, arg4, arg5, arg6,  &DatoInt[t] , arg8, &arg9 ) != SQL_SUCCESS)
										{
											printf("\n Existio un Problema al Ligar Parametro");
										}
										else
										{
											printf("\n EL Parametro se ligo Satisfactoriamente");
										
										}

								}	


										

							}

						}
						
					}		




								
								pdest = strstr(strupr(AuxszBuffer),"SQLEXECDIRECT");

							    if (pdest != NULL || z>0) 
							

								{

									z++;

									if(z>1)
									{

									sprintf(textopantalla,"\r\n Msg(%d). \r\n Sentencia SQL a Ejecutar [%s]", ++nummsg, szBuffer);
									printf("%s", textopantalla);

							
									// Ejecuta Sentencia
                           
									if(SQLExecDirect(CnBd.StmtHandle, (UCHAR *) szBuffer, SQL_NTS) != SQL_SUCCESS)
									{
										printf("\n Existio un Problema al Ejecutar Sentencia");
									}
									else
									{
										printf("\n La Sentencia se Ejecuto Satisfactoriamente");
									}
									
									z=0;

									}



								}

									


							    

						}

	                      
			
				 } while(peticion!='d');  
	 

			} else
			{ 
			  printf("\n El sistema operativo no Permite Sentencia (SQLAllocStmt) a la Base de Datos");
			}

  
		}else
		{ 
			printf("\n El sistema operativo no Permite Conexin (SQLConnect) a la Base de Datos");
		}


	}else
 
  { 
    printf("\n El sistema operativo no Permite Conexin (SQLAllowHandle) a la Base de Datos");
  }



  
  }else
 
  { 
    printf("\n El sistema operativo no soporta la comunicacin por Sockets");
  }

        return  0;

}