//Header Servidor


#include <winsock.h>
#include <sys/types.h> 
#include <stdio.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#include <iostream.h>



const int DefaultTTL=1;

const int ERRBASE=65536;
const int OK=0;
const int ESEND   	=	ERRBASE+1; 
const int ERECV   	=	ERRBASE+2; 
const int ETIMEOUT  = ERRBASE+3;


class Csockbase
{
 public:
  struct sockaddr_in  addr;        // direccin  
  int                 lenaddr;     // longitud de la direccion
  int                 sock;        // socket
  int				  err;
  int				  retval;
};


class CServidor : protected Csockbase
{
  long bytes_recibidos;
  struct sockaddr_in addrservicio,addrcliente;  
 
  public: 
  CServidor(const char *SrcIPAddr=0,int IPPort=0);
  ~CServidor();
  int servicio(char *bufdatosIn, long maxdatos, long &datosleidos);
  
};





//Aqui creo la instancia

CServidor::CServidor(const char *SrcIPAddr,int IPPort)

{
  

	if (( sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) 
    	printf("Error creando socket SOCK_STREAM");
	
 
	 memset(&addr, 0, sizeof (addr));         
	 addr.sin_family = AF_INET;
		
	  if(!SrcIPAddr)
                   addr.sin_addr.s_addr = INADDR_ANY;
	  else 
	    addr.sin_addr.s_addr= inet_addr(SrcIPAddr);
	    addr.sin_port = htons(IPPort);
	    lenaddr=sizeof(addr);
	
	  //Se asocia el socket TCP a la direccion de recepcion

	  if (bind (sock, (struct sockaddr *) &addr, lenaddr) == -1 ) 
	    throw ("Error en bind");
	       if(getsockname(sock,(struct sockaddr *)&addr,&lenaddr)==-1)
	          throw ("error en getsockname");
	  listen(sock,5);

 
}



CServidor::~CServidor()
{
   //destruir la conexion si sigue activa y hacer limpieza
   closesocket(sock);
}


int CServidor::servicio(char *bufdatosIn,  long maxdatosInOut, 
                       long &datosleidos)
{
  //Primero se construye la estructura de timeouts
  //Un conjunto de sockets a comprobar si tienen peticiones
  fd_set set;
  FD_ZERO(&set);
  FD_SET(sock,&set);
  //...No hay tiempo mximo a esperar si hay buffer de entrada
  struct timeval tval;
  tval.tv_sec=0;
  tval.tv_usec=NULL;

  
  int result=select(0,&set,0,0,&tval);
  if(result==0) return ETIMEOUT;  //retornar si cumple tiempo espera 
  //hay peticin y se procesa. 
  int sockacept=accept(sock,(struct sockaddr *) &addr, (int *) &lenaddr );
  if(sockacept==-1) 
    throw("Error en accept");
  //obtenemos datos del socket creado por el sistema para atender
  //el servicio
	int lenaddrservicio= sizeof addr;
  if( getsockname( sockacept, (struct sockaddr *) &addrservicio, 
                   &lenaddrservicio ) ==-1)  
	  throw("Error averiguando sockaddr_in del socket asignado para el servicio");

  //obtenemos los datos del cliente conectado al socket
	int lenaddrcliente= sizeof addrcliente;
  if( getpeername( sockacept, (struct sockaddr *) &addrcliente, 
                   &lenaddrcliente ) ==-1)  
	  throw("Error averiguando sockaddr_in del socket cliente conectado a este");

  
  
  //Con los datos del cliente se podra decidir si se acepta o no
  //la peticin...
  //Se reciben los datos.
  retval=recv(sockacept,bufdatosIn,maxdatosInOut,0);
  if (retval==-1) 
    throw("Error en recv");
  datosleidos=retval;

  //damos por terminada la comunicacin.

  closesocket(sockacept);
  return OK;
}



