#include <windows.h>
#include <sql.h>
#include <sqlext.h>

//Clase de Conexin a la Base de Datos


// Define la Clase de Conexin ODBC_Class 
class ODBC_Class
{
    // Atributos
    public:
        SQLHANDLE    EnvHandle;
        SQLHANDLE    ConHandle;
		SQLHANDLE    StmtHandle;
        SQLRETURN    rc;

    // Operaciones
    public:
        ODBC_Class();                        // Constructor
        ~ODBC_Class();                       // Destructor
};

// Define el Constructor de la Clase
ODBC_Class::ODBC_Class()
{
    // Inicializa la variable de Cdigo de Retorno
    rc = SQL_SUCCESS;

    // Almacena espacio para un Handle de Ambiente
    rc = SQLAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HANDLE, &EnvHandle);

    // Asigna la Aplicacin ODBC a la Version To 3.x
    if (rc == SQL_SUCCESS)
        rc = SQLSetEnvAttr(EnvHandle, SQL_ATTR_ODBC_VERSION, 
                 (SQLPOINTER) SQL_OV_ODBC3, SQL_IS_UINTEGER);

    // Almacena espacio para un Handle de Conexin
    if (rc == SQL_SUCCESS)
        rc = SQLAllocHandle(SQL_HANDLE_DBC, EnvHandle, &ConHandle);
}

// Define el Destructor de la Clase
ODBC_Class::~ODBC_Class()
{
    // Libera el Handle de Conexin 
    if (ConHandle != NULL)
        SQLFreeHandle(SQL_HANDLE_DBC, ConHandle);

    // Libera El Handle de  Ambiente 
    if (EnvHandle != NULL)
        SQLFreeHandle(SQL_HANDLE_ENV, EnvHandle);
}
